(* Exemple ralis par
**
** Par Laurent LE BRUN (LLB) e-mail: llb@fr.fm
**   Venez sur mon site "Le Temple de la Programmation "(www.llb.fr.fm)
**   pour retrouver :
**      o de nombreux tutoriels (dont celui qui correspond  cet exemple)
**      o des trucs et astuces
**      o des liens
**      o etc.
**    sur DELPHI, le HTML et le JAVASCRIPT
**
**
** D'aprs un exemple de Lionel ROUVAREL
**   e-mail: lionel27@club-internet.fr
**   site : "LioCity" http://perso.club-internet.fr/lionel27
**
**
** Fini le 10/11/01
**  (dernire version sur www.llb.fm.fm)
*)

unit loupeUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    tbar: TTrackBar;
    img: TImage;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure tbarChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  close;
end;

procedure Loupe(x, y, Size: Integer);
var
  Cadre1, Cadre2: TRect;
begin
  // dfinition d'un carr centr sur la position de la souris
  Cadre1.Top := y - Size - Form1.Top - GetSystemMetrics(SM_CYCAPTION);
  Cadre1.Left := x - Size - Form1.Left;
  Cadre1.Right := x + Size - Form1.Left;
  Cadre1.Bottom := y + Size -Form1.Top - GetSystemMetrics(SM_CYCAPTION);

  // On rcupre la taille de l'image pour afficher dedans l'image aggrandie.
  Cadre2.Top := 0;
  Cadre2.Left := 0;
  Cadre2.Right := Form1.Img.Width;
  Cadre2.Bottom := Form1.img.Height;

  Form1.Img.Canvas.CopyRect(Cadre2, Form1.Canvas, Cadre1);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Loupe(Mouse.CursorPos.x, Mouse.CursorPos.y, TBar.Position);
end;

procedure TForm1.tbarChange(Sender: TObject);
begin
  Label1.Caption := IntToStr(100 * 100 div (TBar.Position * 2))+' %';
end;

end.
